From 9fa7eab5f66fb47f6e817574c13a0767246dbb03 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Jun 30 2016 09:55:41 +0000
Subject: [PATCH 501/1001] Replace openid by username in the model


With the move from openid to openid-connect, there are no more openid url
that we can rely on.
Apparently, there is also nothing else than the username we can use that
would uniquely identify the user while being stable over multiple hosts.

---

diff --git a/hubs/models.py b/hubs/models.py
index 681048b..ad3bc16 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -45,13 +45,13 @@ from hubs.utils import username2avatar
 
 
 class HubsBase(object):
-    def notify(self, openid, changed):
+    def notify(self, username, changed):
         obj = type(self).__name__.lower()
         topic = obj + ".update"
         fedmsg.publish(
             topic=topic,
             msg=dict(
-                openid=openid,
+                username=username,
                 changed=changed,
             )
         )
@@ -103,7 +103,7 @@ class Association(BASE):
                        sa.ForeignKey('hubs.name'),
                        primary_key=True)
     user_id = sa.Column(sa.Text,
-                        sa.ForeignKey('users.openid'),
+                        sa.ForeignKey('users.username'),
                         primary_key=True)
     role = sa.Column(sa.Enum(*roles), primary_key=True)
 
@@ -350,14 +350,13 @@ class Widget(BASE):
 
 class User(BASE):
     __tablename__ = 'users'
-    openid = sa.Column(sa.Text, primary_key=True)
+    username = sa.Column(sa.Text, primary_key=True)
     fullname = sa.Column(sa.Text)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
 
     def __json__(self, session):
         return {
             'username': self.username,
-            'openid': self.openid,
             'avatar': username2avatar(self.username),
             'fullname': self.fullname,
             'created_on': self.created_on,
@@ -396,32 +395,24 @@ class User(BASE):
             and assoc.hub.name != self.username
         ])), key=operator.attrgetter('name'))
 
-    @property
-    def username(self):
-        return self.openid.split('.')[0]
-
     @classmethod
     def by_username(cls, session, username):
-        return cls.by_openid(session, "%s.id.fedoraproject.org" % username)
-
-    @classmethod
-    def by_openid(cls, session, openid):
-        return session.query(cls).filter_by(openid=openid).first()
+        return session.query(cls).filter_by(username=username).first()
 
-    get = by_openid
+    get = by_username
 
     @classmethod
     def all(cls, session):
         return session.query(cls).all()
 
     @classmethod
-    def get_or_create(cls, session, openid, fullname):
-        if not openid:
-            raise ValueError("Must provide openid, not %r" % openid)
+    def get_or_create(cls, session, username, fullname):
+        if not username:
+            raise ValueError("Must provide an username, not %r" % username)
 
-        self = cls.by_openid(session, openid)
+        self = cls.by_username(session, username)
         if not self:
-            self = cls(openid=openid, fullname=fullname)
+            self = cls(username=username, fullname=fullname)
             session.add(self)
             if not Hub.by_name(session, self.username):
                 Hub.create_user_hub(session, self.username, self.fullname)

